package sun.net.www.protocol.netdoc;

import java.io.IOException;
import java.net.MalformedURLException;
import sun.security.action.GetPropertyAction;
import java.security.AccessController;
import sun.security.action.GetBooleanAction;
import java.net.URLConnection;
import java.net.URL;
import java.net.URLStreamHandler;

public class Handler extends URLStreamHandler
{
    static URL base;
    
    public Handler() {
    }
    
    public synchronized URLConnection openConnection(URL url) throws IOException {
        URLConnection urlConnection = null;
        int booleanValue = (boolean)AccessController.doPrivileged(new GetBooleanAction("newdoc.localonly"));
        String spec = (String)AccessController.doPrivileged(new GetPropertyAction("doc.url"));
        String file = url.getFile();
        if (booleanValue == 0) {
            URL url2;
            try {
                if (Handler.base == null) {
                    Handler.base = new URL(spec);
                }
                url2 = new URL(Handler.base, file);
            }
            catch (MalformedURLException ex) {
                url2 = null;
            }
            if (url2 != null) {
                urlConnection = url2.openConnection();
            }
        }
        if (urlConnection == null) {
            try {
                urlConnection = new URL("file", "~", file).openConnection();
                urlConnection.getInputStream();
            }
            catch (MalformedURLException ex2) {
                urlConnection = null;
            }
            catch (IOException ex3) {
                urlConnection = null;
            }
        }
        if (urlConnection == null) {
            throw new IOException("Can't find file for URL: " + url.toExternalForm());
        }
        return urlConnection;
    }
}
